#ifndef CPHIDGET_CONSTANTS
#define CPHIDGET_CONSTANTS

/** \defgroup phidconst Phidget Constants 
 * @{
 */

/** @{ \name Phidget States
 * Returned by getStatus() functions
 */
#define PHIDGET_ATTACHED				0x1 /**< Phidget attached */
#define PHIDGET_NOTATTACHED				0x0 /**< Phidget not attached */
/** @} */

/** @{ \name Phidget Error Codes
 * Returned by all C API calls
 */
#define	PHIDGET_ERROR_CODE_COUNT		18
#define EPHIDGET_OK						0
#define EPHIDGET_NOTFOUND				1
#define EPHIDGET_NOMEMORY				2
#define EPHIDGET_UNEXPECTED				3
#define EPHIDGET_INVALIDARG				4
#define EPHIDGET_NOTATTACHED			5
#define EPHIDGET_INTERRUPTED			6
#define EPHIDGET_INVALID				7
#define EPHIDGET_NETWORK				8
#define EPHIDGET_UNKNOWNVAL				9
#define EPHIDGET_BADPASSWORD			10
#define EPHIDGET_UNSUPPORTED			11
#define EPHIDGET_DUPLICATE				12
#define EPHIDGET_TIMEOUT				13
#define EPHIDGET_OUTOFBOUNDS			14
#define EPHIDGET_EVENT					15
#define EPHIDGET_NETWORK_NOTCONNECTED	16
#define EPHIDGET_WRONGDEVICE			17
/** @} */

/** @{ \name Phidget Unknown Constants
 * Set for unknown values
 */
#define PUNK_BOOL	0x02 /**< Unknown Boolean (unsigned char) */
#define PUNK_INT	0x7FFFFFFF
#define PUNK_INT64	0x7FFFFFFFFFFFFFFFLL
#define PUNK_DBL	1e300
#define PUNK_FLT	1e30
/** @} */

#define PFALSE		0x00
#define PTRUE		0x01

/** @} */

#endif

