#ifndef __CPHIDGETMOTORCONTROL
#define __CPHIDGETMOTORCONTROL
#include "cphidget.h"

/** \defgroup phidmotorcontrol Phidget Motor Control 
 * \ingroup phidgets
 * @{
 */

DPHANDLE(MotorControl)
CHDRSTANDARD(MotorControl)

CHDRGET(MotorControl,MotorCount,int *count)

CHDRGETINDEX(MotorControl,Velocity,double *velocity)
CHDRSETINDEX(MotorControl,Velocity,double velocity)
CHDREVENTINDEX(MotorControl,VelocityChange,double velocity)

CHDRGETINDEX(MotorControl,Acceleration,double *acceleration)
CHDRSETINDEX(MotorControl,Acceleration,double acceleration)
CHDRGETINDEX(MotorControl,AccelerationMax,double *max)
CHDRGETINDEX(MotorControl,AccelerationMin,double *min)

CHDRGETINDEX(MotorControl,Current,double *current)
CHDREVENTINDEX(MotorControl,CurrentChange,double current)

CHDRGET(MotorControl,InputCount,int *count)
CHDRGETINDEX(MotorControl,InputState,int *inputState)
CHDREVENTINDEX(MotorControl,InputChange,int inputState)

#ifndef REMOVE_DEPRECATED
DEP_CHDRGET("Deprecated - use CPhidgetMotorControl_getMotorCount",MotorControl,NumMotors,int *)
DEP_CHDRGET("Deprecated - use CPhidgetMotorControl_getInputCount",MotorControl,NumInputs,int *)
DEP_CHDRGETINDEX("Deprecated - use CPhidgetMotorControl_getVelocity",MotorControl,MotorSpeed,double *)
DEP_CHDRSETINDEX("Deprecated - use CPhidgetMotorControl_setVelocity",MotorControl,MotorSpeed,double)
DEP_CHDREVENTINDEX("Deprecated - use CPhidgetMotorControl_set_OnVelocityChange_Handler",MotorControl,MotorChange,double motorSpeed)
#endif

#ifndef EXTERNALPROTO
#define MOTORCONTROL_MAXMOTORS 2
#define MOTORCONTROL_MAXINPUTS 4
struct _CPhidgetMotorControl {
	CPhidget phid;
   
	int (CCONV *fptrVelocityChange)(CPhidgetMotorControlHandle, void *, int, double);               
	int (CCONV *fptrInputChange)(CPhidgetMotorControlHandle, void *, int, int);     
	int (CCONV *fptrCurrentChange)(CPhidgetMotorControlHandle, void *, int, double);       

	void *fptrInputChangeptr;
	void *fptrVelocityChangeptr;
	void *fptrCurrentChangeptr;

	//Deprecated
	int (CCONV *fptrMotorChange)(CPhidgetMotorControlHandle, void *, int, double);   
	void *fptrMotorChangeptr;

	unsigned char inputState[MOTORCONTROL_MAXINPUTS];
	double motorSpeedEcho[MOTORCONTROL_MAXMOTORS];
	double motorSensedCurrent[MOTORCONTROL_MAXMOTORS];

	double motorSpeed[MOTORCONTROL_MAXMOTORS];
	double motorAcceleration[MOTORCONTROL_MAXMOTORS];

	double accelerationMax, accelerationMin;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetMotorControlInfo;
#endif

/** @} */

#endif
