#ifndef __CPHIDGETPHSENSOR
#define __CPHIDGETPHSENSOR
#include "cphidget.h"

/** \defgroup phidph Phidget PH Sensor 
 * \ingroup phidgets
 * @{
 */

DPHANDLE(PHSensor)
CHDRSTANDARD(PHSensor)

CHDRGET(PHSensor,PH,double *ph)
CHDRGET(PHSensor,PHMax,double *max)
CHDRGET(PHSensor,PHMin,double *min)
CHDREVENT(PHSensor,PHChange,double ph)
CHDRGET(PHSensor,PHChangeTrigger,double *trigger)
CHDRSET(PHSensor,PHChangeTrigger,double trigger)

CHDRGET(PHSensor,Potential,double *potential)
CHDRGET(PHSensor,PotentialMax,double *max)
CHDRGET(PHSensor,PotentialMin,double *min)

CHDRSET(PHSensor,Temperature,double temperature)

#ifndef EXTERNALPROTO
struct _CPhidgetPHSensor {
	CPhidget phid;

	int (CCONV *fptrPHChange)(CPhidgetPHSensorHandle, void *, double);

	void *fptrPHChangeptr;

	double PH, Potential;
	double PHLastTrigger;
	double PHChangeTrigger;

	double Temperature;

	double phMax, phMin;
	double potentialMax, potentialMin;
} typedef CPhidgetPHSensorInfo;
#endif

/** @} */

#endif
