#ifndef __CPHIDGETRFID
#define __CPHIDGETRFID
#include "cphidget.h"

/** \defgroup phidrfid Phidget RFID 
 * \ingroup phidgets
 * @{
 */

DPHANDLE(RFID)
CHDRSTANDARD(RFID)

CHDRGET(RFID,OutputCount,int *count)
CHDRGETINDEX(RFID,OutputState,int *outputState)
CHDRSETINDEX(RFID,OutputState,int outputState)
CHDREVENTINDEX(RFID,OutputChange,int outputState)

CHDRGET(RFID,AntennaOn,int *antennaState)
CHDRSET(RFID,AntennaOn,int antennaState)
CHDRGET(RFID,LEDOn,int *LEDState)
CHDRSET(RFID,LEDOn,int LEDState)

CHDRGET(RFID,LastTag,unsigned char *tag)
CHDRGET(RFID,TagStatus,int *status)
CHDREVENT(RFID,Tag,unsigned char *tag)
CHDREVENT(RFID,TagLost,unsigned char *tag)

#ifndef REMOVE_DEPRECATED
DEP_CHDRGET("Deprecated - use CPhdigetRFID_getOutputCount",RFID,NumOutputs,int *)
#endif

#ifndef EXTERNALPROTO

#define RFID_PACKET_TAG 0
#define RFID_PACKET_OUTPUT_ECHO 1

#define RFID_LED_FLAG 0x04
#define RFID_ANTENNA_FLAG 0x08

#define RFID_MAXOUTPUTS 2

struct _CPhidgetRFID {
	CPhidget phid;

	int (CCONV *fptrOutputChange)(CPhidgetRFIDHandle, void *, int, int);
	int (CCONV *fptrTag)(CPhidgetRFIDHandle, void *, unsigned char *);
	int (CCONV *fptrTagLost)(CPhidgetRFIDHandle, void *, unsigned char *);

	void *fptrOutputChangeptr;
	void *fptrTagptr;
	void *fptrTagLostptr;

	// Values returned from the device
	unsigned char outputEchoState[RFID_MAXOUTPUTS];
	unsigned char antennaEchoState;
	unsigned char ledEchoState;
	
	unsigned char outputState[RFID_MAXOUTPUTS];
	unsigned char antennaState;
	unsigned char ledState;

	unsigned char lastTag[5];
	TIME	lastTagTime;
	unsigned char tagPresent;

	unsigned char fullStateEcho;
	
	CThread tagTimerThread;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetRFIDInfo;
#endif

/** @} */

#endif
