#ifndef __CPHIDGETTEXTLCD
#define __CPHIDGETTEXTLCD
#include "cphidget.h"

/** \defgroup phidtextlcd Phidget TextLCD 
 * \ingroup phidgets
 * @{
 */

DPHANDLE(TextLCD)
CHDRSTANDARD(TextLCD)

CHDRGET(TextLCD,RowCount,int *count)
CHDRGET(TextLCD,ColumnCount,int *count)

CHDRGET(TextLCD,Backlight,int *backlightState)
CHDRSET(TextLCD,Backlight,int backlightState)
CHDRGET(TextLCD,Contrast,int *contrast)
CHDRSET(TextLCD,Contrast,int constrast)
CHDRGET(TextLCD,CursorOn,int *cursorState)
CHDRSET(TextLCD,CursorOn,int cursorState)
CHDRGET(TextLCD,CursorBlink,int *cursorBlinkState)
CHDRSET(TextLCD,CursorBlink,int cursorBlinkState)

CHDRSETINDEX(TextLCD,CustomCharacter,int var1,int var2)
CHDRSETINDEX(TextLCD,DisplayCharacter,int Column,unsigned char character)
CHDRSETINDEX(TextLCD,DisplayString,char *displayString)

#ifndef REMOVE_DEPRECATED
DEP_CHDRGET("Deprecated - use CPhidgetTextLCD_getRowCount",TextLCD,NumRows,int *)
DEP_CHDRGET("Deprecated - use CPhidgetTextLCD_getColumnCount",TextLCD,NumColumns,int *)
#endif

#ifndef EXTERNALPROTO
#define TEXTLCD_MAXROWS 2
#define TEXTLCD_MAXCOLS 20

#define TEXTLCD_BACKLIGHT_PACKET	0x01
#define TEXTLCD_CONTRAST_PACKET		0x02
#define TEXTLCD_CURSOR_PACKET		0x03

struct _CPhidgetTextLCD {
	CPhidget phid;

	unsigned char m_blnCursorOn,m_blnCursorBlink,m_blnBacklight;
	int m_iContrast;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetTextLCDInfo;
#endif

/** @} */

#endif
