#ifndef __CPHIDGETTEXTLED
#define __CPHIDGETTEXTLED
#include "cphidget.h"

/** \defgroup phidtextled Phidget TextLED 
 * \ingroup phidgets
 * @{
 */

DPHANDLE(TextLED)
CHDRSTANDARD(TextLED)

CHDRGET(TextLED,RowCount,int *count)
CHDRGET(TextLED,ColumnCount,int *count)

CHDRGET(TextLED,Brightness,int *brightness)
CHDRSET(TextLED,Brightness,int brightness)

CHDRSETINDEX(TextLED,DisplayString,char *displayString)

#ifndef REMOVE_DEPRECATED
DEP_CHDRGET("Deprecated - use CPhidgetTextLED_getRowCount",TextLED,NumRows,int *)
DEP_CHDRGET("Deprecated - use CPhidgetTextLED_getColumnCount",TextLED,NumColumns,int *)
#endif

#ifndef EXTERNALPROTO
#define TEXTLED_MAXROWS 4
#define TEXTLED_MAXCOLS 8

#define TEXTLED_BRIGHTNESS_PACKET -1
#define TEXTLED_DISPLAYSTRING_PACKET 0

struct _CPhidgetTextLED {
	CPhidget phid;

	char *displayStringPtr[TEXTLED_MAXROWS];
	int brightness;

	unsigned char outputPacket[24];
	unsigned int outputPacketLen;
} typedef CPhidgetTextLEDInfo;
#endif

/** @} */

#endif
